<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
import promotionService from '@/service/promotion'
import { usePromotionStore } from '@/stores/promotion'
import type { Promotion } from '@/types/Promotion'
const promotionStore = usePromotionStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Starting date',
    key: 'startdate',
    value: 'startdate'
  },
  {
    title: 'End date',
    key: 'enddate',
    value: 'enddate'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { title: 'Discount', key: 'discount', value: 'discount' }
]
const loadingStone = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilPromotion: Promotion = {
  id: -1,
  name: '',
  startdate: null,
  enddate: null,
  status: 'Inactive',
  discount: 0
}
const editedPromotion = ref<Promotion>(JSON.parse(JSON.stringify(initilPromotion)))

let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedPromotion.value = Object.assign({}, initilPromotion)
  })
}
async function deleteItemConfirm() {
  closeDelete()
  // Delete item from list
  await promotionStore.deletePromotion(editedPromotion.value)
}
function editItem(item: Promotion) {
  editedPromotion.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Promotion) {
  editedPromotion.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedPromotion.value = Object.assign({}, initilPromotion)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  closeDialog()
  await promotionStore.savePromotion(editedPromotion.value)
}
const addpromotion = () => {
  editedIndex += 1
  dialog.value = true
}
onMounted(() => {
  promotionStore.getPromotions()
})
</script>
<template>
  <div id="app" class="d-flex justify-center">
    <v-card
      variant="tonal"
      width="100%"
      min-width="500"
      max-width="1200"
      max-height="600"
      min-height="750"
      class="ma-3 bg-teal-darken-4"
      :elevation="18"
    >
      <v-card variant="tonal" class="ma-2 bg-teal-darken-4">
        <div
          style="
            background-color: rgb(0, 0, 0);
            color: aliceblue;
            text-align: center;
            font-size: 50px;
            font-family: Arial, Helvetica, sans-serif;
          "
        >
          Member CRUD
        </div>
        <v-container>
          <div class="d-flex justify-center">
            <v-card min-width="500" max-width="1200" height="auto" elevation="6">
              <v-table fixed-header height="550px" style="overflow: auto; width: 2000px">
                <thead>
                  <tr>
                    <th class="text-center">ID</th>
                    <th class="text-center">Promotion Name</th>
                    <th class="text-center">Starting date</th>
                    <th class="text-center">End date</th>
                    <th class="text-center">Discount</th>
                    <th class="text-center">Status</th>
                    <th class="text-center"></th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in promotionStore.promotions" :key="item.id">
                    <td class="text-center">{{ item.id }}</td>
                    <td class="text-center">{{ item.name }}</td>
                    <td class="text-center">{{ item.startdate }}</td>
                    <td class="text-center">{{ item.enddate }}</td>
                    <td class="text-center">{{ item.discount }}</td>
                    <td class="text-center">{{ item.status }}</td>
                    <td class="text-center">
                      <v-btn
                        class="mx-2"
                        icon="mdi-pencil"
                        density="compact"
                        color="light-green-darken-3"
                        @click="editItem(item)"
                      >
                      </v-btn>
                      <v-btn
                        icon="mdi-trash-can"
                        density="compact"
                        color="deep-orange-darken-4"
                        @click="
                          () => {
                            deleteItem(item)
                          }
                        "
                      ></v-btn>
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-card>
          </div>
        </v-container> </v-card
      ><v-btn
        class="mt-3"
        style="align-self: flex-end; margin-left: 87.6%"
        color="green-darken-3"
        @click="addpromotion()"
        >Add +</v-btn
      >
    </v-card>
  </div>

  <div>
    <v-dialog v-model="dialog" persistent width="1024">
      <v-card>
        <v-card-title>
          <span class="text-h5">Promotion</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field
                    v-model="editedPromotion.name"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="Promotion name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field
                    v-model="editedPromotion.startdate"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="Starting date"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field
                    v-model="editedPromotion.enddate"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    clearable
                    label="End date"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6">
                  <v-combobox
                    label="Status"
                    :items="['Active', 'Inactive']"
                    v-model="editedPromotion.status"
                  ></v-combobox>
                </v-col>
                <v-col cols="12" sm="6">
                  <v-text-field
                    v-model="editedPromotion.discount"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    clearable
                    label="Discount"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- Delete Dialog-->
    <v-dialog v-model="dialogDelete" max-width="500px">
      <v-card>
        <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
